typedef int datatype;
typedef struct Node
{
	int data;
	
	struct Node *next;
}NODE;

typedef struct Node_Int
{
  NODE *node;
  int num;
}NODE_INT;

void print_node_at(NODE *head, int pos);
void print_list(NODE *head);
void print_node(NODE *head);
NODE_INT psearch(NODE *head, datatype data);
NODE_INT search(NODE *head, datatype data);
NODE *construct(datatype data, NODE *next);
NODE_INT traverse(NODE *head, int pos);
//NODE_INT traverse_before(NODE *head, int pos, int before);
int delete_node_after(NODE *head);
void delete_list(NODE *head);
//int delete_node_at(NODE *head, int pos);
//int delete_node(NODE *head, datatype data);
NODE *construct_list(datatype list[], int size);
int add_to_end(NODE *head, datatype new_data);
int insert_node(NODE *head, int pos, datatype new_data);
int insert_node_after(NODE *head, datatype data);
int length(NODE *head);
